VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Delete Array Element Example"
   ClientHeight    =   3645
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   4530
   LinkTopic       =   "Form1"
   ScaleHeight     =   3645
   ScaleWidth      =   4530
   StartUpPosition =   3  'Windows Default
   Begin VB.Frame frameTwo 
      Caption         =   "Method Two"
      Height          =   3495
      Left            =   2310
      TabIndex        =   1
      Top             =   90
      Width           =   2115
      Begin VB.TextBox Text4 
         Alignment       =   1  'Right Justify
         Height          =   315
         Left            =   1260
         TabIndex        =   12
         Text            =   "4000"
         Top             =   1440
         Width           =   735
      End
      Begin VB.TextBox Text3 
         Height          =   315
         Left            =   90
         TabIndex        =   11
         Text            =   "1,2,3,4,5,6,7,8,9,10,11,12"
         Top             =   2310
         Width           =   1935
      End
      Begin VB.CommandButton Command2 
         Caption         =   "Test"
         Height          =   375
         Left            =   480
         TabIndex        =   10
         Top             =   2760
         Width           =   1125
      End
      Begin VB.Label Label8 
         Alignment       =   1  'Right Justify
         Caption         =   "# of Elements"
         Height          =   195
         Left            =   60
         TabIndex        =   15
         Top             =   1500
         Width           =   1065
      End
      Begin VB.Label Label7 
         Caption         =   "Remove Elements (comma to separate)"
         Height          =   405
         Left            =   90
         TabIndex        =   14
         Top             =   1890
         Width           =   1575
      End
      Begin VB.Label Label6 
         Alignment       =   2  'Center
         Caption         =   "(Results Here)"
         Height          =   195
         Left            =   90
         TabIndex        =   13
         Top             =   3240
         Width           =   1935
      End
      Begin VB.Label Label2 
         BackStyle       =   0  'Transparent
         Caption         =   "Method 2 uses the alternate 'array shift' method which moves around blocks of memory instead."
         Height          =   885
         Left            =   90
         TabIndex        =   3
         Top             =   300
         Width           =   1965
      End
   End
   Begin VB.Frame frameOne 
      Caption         =   "Method One"
      Height          =   3495
      Left            =   60
      TabIndex        =   0
      Top             =   90
      Width           =   2115
      Begin VB.CommandButton Command1 
         Caption         =   "Test"
         Height          =   375
         Left            =   480
         TabIndex        =   8
         Top             =   2760
         Width           =   1125
      End
      Begin VB.TextBox Text2 
         Height          =   315
         Left            =   90
         TabIndex        =   6
         Text            =   "1,2,3,4,5,6,7,8,9,10,11,12"
         Top             =   2310
         Width           =   1935
      End
      Begin VB.TextBox Text1 
         Alignment       =   1  'Right Justify
         Height          =   315
         Left            =   1260
         TabIndex        =   4
         Text            =   "4000"
         Top             =   1440
         Width           =   735
      End
      Begin VB.Label Label5 
         Alignment       =   2  'Center
         Caption         =   "(Results Here)"
         Height          =   195
         Left            =   90
         TabIndex        =   9
         Top             =   3240
         Width           =   1935
      End
      Begin VB.Label Label4 
         Caption         =   "Remove Elements (comma to separate)"
         Height          =   405
         Left            =   90
         TabIndex        =   7
         Top             =   1890
         Width           =   1575
      End
      Begin VB.Label Label3 
         Alignment       =   1  'Right Justify
         Caption         =   "# of Elements"
         Height          =   195
         Left            =   60
         TabIndex        =   5
         Top             =   1500
         Width           =   1065
      End
      Begin VB.Label Label1 
         BackStyle       =   0  'Transparent
         Caption         =   "Method 1 uses the older, slower, element-for-element copy to delete an item from an array."
         Height          =   885
         Left            =   60
         TabIndex        =   2
         Top             =   300
         Width           =   1965
      End
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Sub Command1_Click()

    Dim strTest() As String
    Dim lngCurrentTime As Long
    Dim i As Long
    Dim Removes As Variant
    
    strTest = CreateArray(200, CLng(Text1.Text))
    
    Removes = Split(Text2.Text, ",")
    
    lngCurrentTime = GetTickCount()
        
    For i = LBound(Removes) To UBound(Removes)
        RemoveArrayElement_Old strTest, CLng(Removes(i))
    Next
    
    Label5.Caption = GetTickCount() - lngCurrentTime & " ticks"
    
End Sub

Private Function CreateArray(Length As Long, Howmany As Long) As String()

    Dim strTest() As String
    Dim i         As Long
    
    ReDim strTest(0 To Howmany)
    
    For i = 0 To Howmany

        strTest(i) = Space(Length)
        
    Next
    
    
    CreateArray = strTest

End Function


Private Sub Command2_Click()

    Dim strTest() As String
    Dim lngCurrentTime As Long
    Dim i As Long
    Dim Removes As Variant
    
    strTest = CreateArray(200, CLng(Text4.Text))
    
    Removes = Split(Text3.Text, ",")
    
    lngCurrentTime = GetTickCount()
        
    For i = LBound(Removes) To UBound(Removes)
        RemoveArrayElement_Str strTest, CLng(Removes(i))
    Next
    
    Label6.Caption = GetTickCount() - lngCurrentTime & " ticks"

End Sub
